variables:
  GIT_SUBMODULE_STRATEGY: recursive
  DOCKER_DRIVER: overlay2
  PUBLIC_URL: "/ndmvr" # slash is important

image: docker:stable
stages:
  - prerequisites
  - build
  - test
  - deploy

services:
  - docker:dind
    
naf-image:
  stage: prerequisites
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker build --tag $CI_REGISTRY_IMAGE/ndmvr-naf:latest -f ci/Dockerfile.naf .
    - docker push $CI_REGISTRY_IMAGE/ndmvr-naf:latest
  when: manual
  allow_failure: true

test-prod:
  stage: test
  image: node:16
  script:
    - CI=true npm install
    - CI=true npm test
    - CI=true npm run predeploy
  except:
    - master

deploy:
  stage: deploy
  image: node:16
  script:
    - "sed -i -e 's/^  \\\"version\\\".*/  \\\"version\\\": \\\"'${CI_COMMIT_REF_NAME/v/}'\\\",/g' package.json"
    - CI=true npm install
    - npm config set //registry.npmjs.org/:_authToken ${NPM_AUTH_TOKEN}
    - CI=true npm publish --access public
  only:
    - tags

pages:
  stage: deploy
  # image: registry.gitlab.com/ndmspc/docs/ndmspc-doc
  image: node:16
  script:
    #- "sed -i -e 's/^  \\\"homepage\\\".*/  \\\"homepage\\\": \\\"\\/ndmvr\\\",/g' example/package.json"
    - CI=true npm install
    - CI=true npm run predeploy
    - rm -rf public
    - mv example/build public
    # - mkdocs build
    # - mv site public/docs
  artifacts:
    paths:
      - public
  only:
    - master
